<?php
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Ambil data dari form
    $id = $_POST['id'];
    $one = $_POST['one'];
    $two = $_POST['two'];
    $three = $_POST['three'];
    $bg = $_POST['bg'];

    // Proses upload untuk gambar background
    if (isset($_FILES['bg']) && $_FILES['bg']['error'] == 0) {
        $bg_file = $_FILES['bg'];
        $bg_name = $bg_file['name'];
        $bg_tmp_name = $bg_file['tmp_name'];
        $bg_size = $bg_file['size'];
        $bg_extension = pathinfo($bg_name, PATHINFO_EXTENSION);
        $allowed_extensions = ['jpg', 'jpeg', 'png', 'gif'];
        $max_size = 5 * 1024 * 1024; // Maksimal 5MB

        if (!in_array(strtolower($bg_extension), $allowed_extensions)) {
            $errorMessage = "Invalid file type. Only JPG, JPEG, PNG, and GIF files are allowed.";
        } elseif ($bg_size > $max_size) {
            $errorMessage = "File size exceeds the maximum limit of 5MB.";
        } else {
            $bg_new_name = uniqid('bg_', true) . '.' . $bg_extension;
            $upload_dir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
            if (move_uploaded_file($bg_tmp_name, $upload_dir . $bg_new_name)) {
                $bg_url = '/uploads/' . $bg_new_name;
            } else {
                $errorMessage = "Error uploading background image.";
            }
        }
    } else {
        $bg_url = $_POST['bg'];
    }

    // Escape input data
    $one = $mysqli->real_escape_string($one);
    $two = $mysqli->real_escape_string($two);
    $three = $mysqli->real_escape_string($three);
    $bg_url = $mysqli->real_escape_string($bg_url);
    $id = (int) $id;

    // Update data jika id tersedia
    if (!empty($id)) {
        $sql = "UPDATE slider SET 
            one = '$one',
            two = '$two',
            three = '$three',
            bg = '$bg_url'
            WHERE id = $id";
        if ($mysqli->query($sql)) {
            $successMessage = "Slider data updated successfully.";
        } else {
            $errorMessage = "Error updating record: " . $mysqli->error;
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Slider Management</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i" rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <h1 class="h3 mb-4 text-gray-800">Slider Management Form</h1>
                    <form action="banner" method="POST" enctype="multipart/form-data">
                        <div class="form-group">
                            <label for="id">ID</label>
                            <input type="number" class="form-control" id="id" name="id" value="<?= htmlspecialchars($slider['id']) ?>" readonly>
                        </div>

                        <div class="form-group">
                            <label for="one">One</label>
                            <input type="text" class="form-control" id="one" name="one" value="<?= htmlspecialchars($slider['one']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="two">Two</label>
                            <input type="text" class="form-control" id="two" name="two" value="<?= htmlspecialchars($slider['two']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="three">Three</label>
                            <input type="text" class="form-control" id="three" name="three" value="<?= htmlspecialchars($slider['three']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="bg">Background Image URL</label>
                            <input type="text" class="form-control" id="bg" name="bg" value="<?= htmlspecialchars($slider['bg']) ?>" readonly>
                        </div>

                        <div class="form-group">
                            <label for="bg">Upload New Background Image</label>
                            <input type="file" class="form-control" id="bg" name="bg" accept="image/*">
                        </div>

                        <button type="submit" class="btn btn-primary">Save Slider Data</button>
                    </form>

                    <?php if (isset($slider['bg']) && !empty($slider['bg'])) : ?>
                        <div class="mt-4">
                            <img src="<?= htmlspecialchars($slider['bg']) ?>" alt="Background Image" class="img-fluid w-25" />
                        </div>
                    <?php endif; ?>
                </div>
            </div>

            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Copyright &copy; Your Website 2021</span>
                    </div>
                </div>
            </footer>
        </div>
    </div>

    <div class="modal fade" id="statusModal" tabindex="-1" role="dialog" aria-labelledby="statusModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="statusModalLabel">Status</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <?php if (!empty($successMessage)) : ?>
                        <div class="alert alert-success">
                            <?php echo $successMessage; ?>
                        </div>
                    <?php elseif (!empty($errorMessage)) : ?>
                        <div class="alert alert-danger">
                            <?php echo $errorMessage; ?>
                        </div>
                    <?php endif; ?>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>

    <script>
        $(document).ready(function() {
            <?php if (!empty($successMessage) || !empty($errorMessage)) : ?>
                $('#statusModal').modal('show');
            <?php endif; ?>
        });
    </script>
</body>

</html>
