<?php
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';
$uploadDir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
$limit = 5;
$page = isset($_GET['page']) ? (int) $_GET['page'] : 1;
$offset = ($page - 1) * $limit;
$totalSql = "SELECT COUNT(*) AS total FROM properties";
$totalResult = $mysqli->query($totalSql);
$totalProperties = $totalResult->fetch_assoc()['total'];
$totalPages = ceil($totalProperties / $limit);
$sql = "SELECT * FROM properties LIMIT $limit OFFSET $offset";
$result = $mysqli->query($sql);

if ($result && $result->num_rows > 0) {
    $properties = $result->fetch_all(MYSQLI_ASSOC);
} else {
    $properties = [];
    $errorMessage = "No properties found.";
}
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_POST['add_property'])) {
        $name = $_POST['name'];
        $location = $_POST['location'];
        $image = null;
        $price_weekday = $_POST['price_weekday'];
        $price_weekend = $_POST['price_weekend'];
        $capacity = $_POST['capacity'];
        $rooms = $_POST['rooms'];
        $beds = $_POST['beds'];
        $bathrooms = $_POST['bathrooms'];
        $facilities = $_POST['facilities'];
        $allowedTypes = ['image/jpeg', 'image/png', 'image/gif', 'image/webp', 'image/svg+xml', 'image/bmp', 'image/tiff'];
        $uploadDir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
        if (!file_exists($uploadDir)) {
            mkdir($uploadDir, 0777, true);
        }

        // Handle single image upload
        if (isset($_FILES['image']) && $_FILES['image']['error'] === 0) {
            $imageTmpPath = $_FILES['image']['tmp_name'];
            $imageName = basename($_FILES['image']['name']);
            $imageExt = pathinfo($imageName, PATHINFO_EXTENSION);
            $uniqueName = uniqid('img_', true) . '.' . $imageExt;
            $imagePath = $uploadDir . $uniqueName;
            if (in_array($_FILES['image']['type'], $allowedTypes)) {
                if (move_uploaded_file($imageTmpPath, $imagePath)) {
                    $image = '/uploads/' . $uniqueName;
                } else {
                    $errorMessage = "Error uploading image.";
                }
            } else {
                $errorMessage = "Invalid image type.";
            }
        }
        $imageUrls = [];
        if (isset($_FILES['image_url']) && isset($_FILES['image_url']['error']) && $_FILES['image_url']['error'][0] === 0) {
            foreach ($_FILES['image_url']['tmp_name'] as $key => $tmpName) {
                $imageUrlTmpPath = $_FILES['image_url']['tmp_name'][$key];
                $imageUrlName = basename($_FILES['image_url']['name'][$key]);
                $imageUrlExt = pathinfo($imageUrlName, PATHINFO_EXTENSION);
                $uniqueImageUrlName = uniqid('img_', true) . '.' . $imageUrlExt;
                $imageUrlPath = $uploadDir . $uniqueImageUrlName;

                if (in_array($_FILES['image_url']['type'][$key], $allowedTypes)) {
                    if (move_uploaded_file($imageUrlTmpPath, $imageUrlPath)) {
                        $imageUrls[] = '/uploads/' . $uniqueImageUrlName;
                    } else {
                        $errorMessage = "Error uploading one of the image URLs.";
                    }
                } else {
                    $errorMessage = "Invalid file type. Only JPEG, PNG, GIF, WEBP, SVG, BMP, TIFF images are allowed.";
                }
            }
        }

        if (empty($errorMessage)) {
            $imageUrlsString = implode(',', $imageUrls);
            $name = $mysqli->real_escape_string($name);
            $location = $mysqli->real_escape_string($location);
            $price_weekday = $mysqli->real_escape_string($price_weekday);
            $price_weekend = $mysqli->real_escape_string($price_weekend);
            $capacity = $mysqli->real_escape_string($capacity);
            $rooms = $mysqli->real_escape_string($rooms);
            $beds = $mysqli->real_escape_string($beds);
            $bathrooms = $mysqli->real_escape_string($bathrooms);
            $facilities = $mysqli->real_escape_string($facilities);
            $insert_sql = "INSERT INTO properties (name,location, image, 
                             price_weekday, price_weekend, capacity, rooms, beds, bathrooms, facilities)
                            VALUES ('$name', '$location', '$image', 
                            '$price_weekday', '$price_weekend', '$capacity', '$rooms', '$beds', '$bathrooms', 
                            '$facilities')";
            if ($mysqli->query($insert_sql)) {
                $successMessage = "Property added successfully.";
            } else {
                $errorMessage = "Error adding property: " . $mysqli->error;
            }
        } else {
            echo $errorMessage;
        }
    }

    if (isset($_POST['edit_property'])) {
        $id = $_POST['id'];
        $name = $_POST['name'];
        $location = $_POST['location'];
        $image = $_POST['current_image'];
        $price_weekday = $_POST['price_weekday'];
        $price_weekend = $_POST['price_weekend'];
        $capacity = $_POST['capacity'];
        $rooms = $_POST['rooms'];
        $beds = $_POST['beds'];
        $bathrooms = $_POST['bathrooms'];
        $facilities = $_POST['facilities'];
        $allowedTypes = ['image/jpeg', 'image/png', 'image/gif'];
        if (isset($_FILES['image']) && $_FILES['image']['error'] === 0) {
            $imageTmpPath = $_FILES['image']['tmp_name'];
            $imageName = basename($_FILES['image']['name']);
            $imageExt = pathinfo($imageName, PATHINFO_EXTENSION);
            $uniqueName = uniqid('img_', true) . '.' . $imageExt;
            $uploadDir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
            $imagePath = $uploadDir . $uniqueName;

            if (in_array($_FILES['image']['type'], $allowedTypes)) {
                if (move_uploaded_file($imageTmpPath, $imagePath)) {
                    $image = '/uploads/' . $uniqueName;
                } else {
                    $errorMessage = "Error uploading image.";
                }
            } else {
                $errorMessage = "Invalid image type. Only JPEG, PNG, and GIF are allowed.";
            }
        }
    
        $id = $mysqli->real_escape_string($id);
        $name = $mysqli->real_escape_string($name);
        $location = $mysqli->real_escape_string($location);
        $image = $mysqli->real_escape_string($image);
        $price_weekday = $mysqli->real_escape_string($price_weekday);
        $price_weekend = $mysqli->real_escape_string($price_weekend);
        $capacity = $mysqli->real_escape_string($capacity);
        $rooms = $mysqli->real_escape_string($rooms);
        $beds = $mysqli->real_escape_string($beds);
        $bathrooms = $mysqli->real_escape_string($bathrooms);
        $facilities = $mysqli->real_escape_string($facilities);
    
        // SQL query to update the property
        $update_sql = "UPDATE properties SET 
                        name = '$name',
                        location = '$location', 
                        image = '$image',
                        price_weekday = '$price_weekday',
                        price_weekend = '$price_weekend',
                        capacity = '$capacity',
                        rooms = '$rooms',
                        beds = '$beds',
                        bathrooms = '$bathrooms',
                        facilities = '$facilities'
                       WHERE id = '$id'";
    
        // Execute the update query
        if ($mysqli->query($update_sql)) {
            $successMessage = "Property updated successfully.";
        } else {
            $errorMessage = "Error updating property: " . $mysqli->error;
        }
    }

    // Delete property section
    if (isset($_POST['delete_property'])) {
        $id = $_POST['id'];
        $delete_sql = "DELETE FROM properties WHERE id = '$id'";

        if ($mysqli->query($delete_sql)) {
            $successMessage = "Property deleted successfully.";
        } else {
            $errorMessage = "Error deleting property: " . $mysqli->error;
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Properties List</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,300,400,600,700" rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <h1 class="h3 mb-4 text-gray-800">Property List</h1>

                    <?php if (!empty($errorMessage)): ?>
                        <div class="alert alert-danger">
                            <?php echo $errorMessage; ?>
                        </div>
                    <?php endif; ?>

                    <?php if (!empty($successMessage)): ?>
                        <div class="alert alert-success">
                            <?php echo $successMessage; ?>
                        </div>
                    <?php endif; ?>
                    <button class="btn btn-primary mb-3" data-toggle="modal" data-target="#addPropertyModal">Add New
                        Property</button>
                    <table class="table table-bordered">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Name</th>
                                <th>Capacity</th>
                                <th>Location</th>
                                <th>Image</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach ($properties as $property): ?>
                                <tr>
                                    <td><?php echo $property['id']; ?></td>
                                    <td><?php echo $property['name']; ?></td>
                                    <td><?php echo $property['capacity']; ?></td>
                                    <td><?php echo $property['location']; ?></td>
                                    <td>
                                        <?php if ($property['image']): ?>
                                            <img src="<?php echo $property['image']; ?>" alt="Property Image" width="100">
                                        <?php endif; ?>
                                    </td>
                                    <td>
                                        <button class="btn btn-warning" data-toggle="modal" data-target="#editModal"
                                            data-id="<?php echo htmlspecialchars($property['id']); ?>"
                                            data-name="<?php echo htmlspecialchars($property['name']); ?>"
                                            data-location="<?php echo htmlspecialchars($property['location']); ?>"
                                            data-image="<?php echo htmlspecialchars($property['image']); ?>"
                                            data-price_weekday="<?php echo htmlspecialchars($property['price_weekday']); ?>"
                                            data-price_weekend="<?php echo htmlspecialchars($property['price_weekend']); ?>"
                                            data-capacity="<?php echo htmlspecialchars($property['capacity']); ?>"
                                            data-rooms="<?php echo htmlspecialchars($property['rooms']); ?>"
                                            data-beds="<?php echo htmlspecialchars($property['beds']); ?>"
                                            data-bathrooms="<?php echo htmlspecialchars($property['bathrooms']); ?>"
                                            data-facilities="<?php echo htmlspecialchars($property['facilities']); ?>">Edit</button>

                                        <form action="" method="POST" class="d-inline">
                                            <input type="hidden" name="id"
                                                value="<?php echo htmlspecialchars($property['id']); ?>">
                                            <button type="submit" name="delete_property"
                                                class="btn btn-danger">Delete</button>
                                        </form>
                                    </td>


                                </tr>
                            <?php endforeach; ?>
                        </tbody>
                    </table>

                    <!-- Pagination -->
                    <nav aria-label="Page navigation">
                        <ul class="pagination">
                            <li class="page-item <?php echo ($page == 1) ? 'disabled' : ''; ?>">
                                <a class="page-link" href="?page=<?php echo $page - 1; ?>">Previous</a>
                            </li>
                            <li class="page-item disabled">
                                <span class="page-link"><?php echo $page; ?></span>
                            </li>
                            <li class="page-item <?php echo ($page == $totalPages) ? 'disabled' : ''; ?>">
                                <a class="page-link" href="?page=<?php echo $page + 1; ?>">Next</a>
                            </li>
                        </ul>
                    </nav>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="addPropertyModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Add New Property</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form action="" method="POST" enctype="multipart/form-data">
                        <!-- Property Name -->
                        <div class="form-group">
                            <label for="name">Property Name</label>
                            <input type="text" class="form-control" name="name" required>
                        </div>

                        <!-- Location -->
                        <div class="form-group">
                            <label for="location">Location</label>
                            <input type="text" class="form-control" name="location" required>
                        </div>

                        <!-- Image -->
                        <div class="form-group">
                            <label for="image">Image</label>
                            <input type="file" class="form-control" name="image" accept="image/*">
                        </div>

                        <!-- Price Weekday -->
                        <div class="form-group">
                            <label for="price_weekday">Price Weekday</label>
                            <input type="number" class="form-control" name="price_weekday" required>
                        </div>

                        <!-- Price Weekend -->
                        <div class="form-group">
                            <label for="price_weekend">Price Weekend</label>
                            <input type="number" class="form-control" name="price_weekend" required>
                        </div>

                        <!-- Capacity -->
                        <div class="form-group">
                            <label for="capacity">Capacity</label>
                            <input type="number" class="form-control" name="capacity" required>
                        </div>

                        <!-- Rooms -->
                        <div class="form-group">
                            <label for="rooms">Rooms</label>
                            <input type="number" class="form-control" name="rooms" required>
                        </div>

                        <!-- Beds -->
                        <div class="form-group">
                            <label for="beds">Beds</label>
                            <input type="number" class="form-control" name="beds" required>
                        </div>

                        <!-- Bathrooms -->
                        <div class="form-group">
                            <label for="bathrooms">Bathrooms</label>
                            <input type="number" class="form-control" name="bathrooms" required>
                        </div>

                        <!-- Facilities -->
                        <div class="form-group">
                            <label for="facilities">Facilities</label>
                            <textarea class="form-control" name="facilities" required></textarea>
                        </div>

                        <!-- Submit Button -->
                        <button type="submit" name="add_property" class="btn btn-primary">Add Property</button>
                    </form>
                </div>
            </div>
        </div>
    </div>



    <!-- Edit Property Modal -->
    <div class="modal fade" id="editModal" tabindex="-1" role="dialog" aria-labelledby="editModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="editModalLabel">Edit Property</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form action="dashboard" method="POST" enctype="multipart/form-data">
                    <div class="modal-body">
                        <!-- Hidden ID field -->
                        <input type="hidden" id="edit_id" name="id">

                        <!-- Name -->
                        <div class="form-group">
                            <label for="edit_name">Name</label>
                            <input type="text" class="form-control" id="edit_name" name="name" required>
                        </div>

                        <!-- Location -->
                        <div class="form-group">
                            <label for="edit_location">Location</label>
                            <input type="text" class="form-control" id="edit_location" name="location" required>
                        </div>

                        <!-- Image (Main Image) -->
                        <div class="form-group">
                            <label for="edit_image">Main Image</label>
                            <input type="file" class="form-control" id="edit_image" name="image" accept="image/*">
                            <input type="hidden" id="current_image" name="current_image">
                        </div>

                        <!-- Price Weekday -->
                        <div class="form-group">
                            <label for="edit_price_weekday">Price Weekday</label>
                            <input type="number" class="form-control" id="edit_price_weekday" name="price_weekday"
                                required>
                        </div>

                        <!-- Price Weekend -->
                        <div class="form-group">
                            <label for="edit_price_weekend">Price Weekend</label>
                            <input type="number" class="form-control" id="edit_price_weekend" name="price_weekend"
                                required>
                        </div>

                        <!-- Capacity -->
                        <div class="form-group">
                            <label for="edit_capacity">Capacity</label>
                            <input type="number" class="form-control" id="edit_capacity" name="capacity" required>
                        </div>

                        <!-- Rooms -->
                        <div class="form-group">
                            <label for="edit_rooms">Rooms</label>
                            <input type="number" class="form-control" id="edit_rooms" name="rooms" required>
                        </div>

                        <!-- Beds -->
                        <div class="form-group">
                            <label for="edit_beds">Beds</label>
                            <input type="number" class="form-control" id="edit_beds" name="beds" required>
                        </div>

                        <!-- Bathrooms -->
                        <div class="form-group">
                            <label for="edit_bathrooms">Bathrooms</label>
                            <input type="number" class="form-control" id="edit_bathrooms" name="bathrooms" required>
                        </div>

                        <!-- Facilities -->
                        <div class="form-group">
                            <label for="edit_facilities">Facilities</label>
                            <textarea class="form-control" id="edit_facilities" name="facilities"></textarea>
                        </div>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary" name="edit_property">Save Changes</button>
                    </div>
                </form>

            </div>
        </div>
    </div>

    <!-- Delete Property Modal -->
    <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="deleteModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="deleteModalLabel">Delete Property</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form action="dashboard" method="POST">
                    <div class="modal-body">
                        <p>Are you sure you want to delete this property?</p>
                        <input type="hidden" id="delete_id" name="id">
                        <p id="delete_name"></p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-danger" name="delete_property">Delete</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>
    <script>
        $('#editModal').on('show.bs.modal', function (event) {
            var button = $(event.relatedTarget);
            var id = button.data('id');
            var name = button.data('name');
            var location = button.data('location');
            var image = button.data('image');
            var price_weekday = button.data('price_weekday');
            var price_weekend = button.data('price_weekend');
            var capacity = button.data('capacity');
            var rooms = button.data('rooms');
            var beds = button.data('beds');
            var bathrooms = button.data('bathrooms');
            var facilities = button.data('facilities');
            var image_urls = button.data('image_url');

            var modal = $(this);
            modal.find('#edit_id').val(id);
            modal.find('#edit_name').val(name);
            modal.find('#edit_location').val(location);
            modal.find('#edit_price_weekday').val(price_weekday);
            modal.find('#edit_price_weekend').val(price_weekend);
            modal.find('#edit_capacity').val(capacity);
            modal.find('#edit_rooms').val(rooms);
            modal.find('#edit_beds').val(beds);
            modal.find('#edit_bathrooms').val(bathrooms);
            modal.find('#edit_facilities').val(facilities);
            modal.find('#current_image_display').attr('src', image);
            modal.find('#current_image').val(image);
            var existingImagesHtml = '';
            if (image_urls) {
                var images = image_urls.split(',');
                images.forEach(function (url) {
                    existingImagesHtml += '<img src="' + url + '" style="width: 100px; margin-right: 10px;"/>';
                });
            }
            modal.find('#existing_images').html(existingImagesHtml);
        });

    </script>

</body>

</html>