<?php
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';

$errorMessage = "";
$successMessage = "";

// Fetch the current footer text values from the database
$sql = "SELECT * FROM footer_text WHERE 1";
$result = $mysqli->query($sql);

if ($result && $result->num_rows > 0) {
    $footerText = $result->fetch_assoc();
} else {
    $errorMessage = "No footer text found.";
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_POST['edit_footer'])) {
        $one = $_POST['one'];
        $two = $_POST['two'];
        $three = $_POST['three'];
        $wa = $_POST['wa']; 
        $domain = $_POST['domain'];

        $alamat = $_POST['alamat'];$maps = $_POST['maps'];

        // Sanitize input
        $one = $mysqli->real_escape_string($one);
        $two = $mysqli->real_escape_string($two);
        $three = $mysqli->real_escape_string($three);
        $wa = $mysqli->real_escape_string($wa);
        $domain = $mysqli->real_escape_string($domain);
        
        $alamat = $mysqli->real_escape_string($alamat);
        
        $maps = $mysqli->real_escape_string($maps);

        // Update the footer_text in the database
        $update_sql = "UPDATE footer_text SET one = '$one', two = '$two', three = '$three', wa = '$wa', domain = '$domain', alamat = '$alamat', maps = '$maps' WHERE id = 1";

        if ($mysqli->query($update_sql)) {
            $successMessage = "Footer text updated successfully.";
        } else {
            $errorMessage = "Error updating footer text: " . $mysqli->error;
        }
    }
}

?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Edit Footer Text</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css?family=Nunito:200,300,400,600,700" rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <h1 class="h3 mb-4 text-gray-800">Edit Footer Text</h1>

                    <?php if (!empty($errorMessage)) : ?>
                        <div class="alert alert-danger">
                            <?php echo $errorMessage; ?>
                        </div>
                    <?php endif; ?>

                    <?php if (!empty($successMessage)) : ?>
                        <div class="alert alert-success">
                            <?php echo $successMessage; ?>
                        </div>
                    <?php endif; ?>

                    <form action="" method="POST">
                        <div class="form-group">
                            <label for="one">Text One</label>
                            <input type="text" class="form-control" id="one" name="one" value="<?php echo isset($footerText['one']) ? $footerText['one'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="two">Text Two</label>
                            <input type="text" class="form-control" id="two" name="two" value="<?php echo isset($footerText['two']) ? $footerText['two'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="three">Text Three</label>
                            <input type="text" class="form-control" id="three" name="three" value="<?php echo isset($footerText['three']) ? $footerText['three'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="wa">WhatsApp Number</label>
                            <input type="text" class="form-control" id="wa" name="wa" value="<?php echo isset($footerText['wa']) ? $footerText['wa'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="wa">Domain</label>
                            <input type="text" class="form-control" id="domain" name="domain" value="<?php echo isset($footerText['domain']) ? $footerText['domain'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="wa">Alamat</label>
                            <input type="text" class="form-control" id="alamat" name="alamat" value="<?php echo isset($footerText['alamat']) ? $footerText['alamat'] : ''; ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="wa">Maps</label>
                            <input type="text" class="form-control" id="maps" name="maps" value="<?php echo isset($footerText['maps']) ? $footerText['maps'] : ''; ?>" required>
                        </div>

                        <button type="submit" name="edit_footer" class="btn btn-primary">Update Footer Text</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>
</body>

</html>
