<?php
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';
$sql_villa = "SELECT id, name FROM properties";
$result_villa = $mysqli->query($sql_villa);

$successMessage = '';
$errorMessage = '';
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['add'])) {
    $id_villa = $_POST['id_villa'];
    $image = isset($_POST['image']) ? $_POST['image'] : '';

    if (isset($_FILES['image_file']) && $_FILES['image_file']['error'] == 0) {
        $image_file = $_FILES['image_file'];
        $image_name = basename($image_file['name']);
        $image_tmp_name = $image_file['tmp_name'];
        $image_size = $image_file['size'];
        $image_extension = pathinfo($image_name, PATHINFO_EXTENSION);
        $allowed_extensions = ['jpg', 'jpeg', 'png', 'gif'];
        $max_size = 5 * 1024 * 1024;

        if (!in_array(strtolower($image_extension), $allowed_extensions)) {
            $errorMessage = "Invalid file type. Only JPG, JPEG, PNG, and GIF files are allowed.";
        } elseif ($image_size > $max_size) {
            $errorMessage = "File size exceeds the maximum limit of 5MB.";
        } else {
            $image_new_name = uniqid('img_', true) . '.' . $image_extension;
            $upload_dir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
            if (move_uploaded_file($image_tmp_name, $upload_dir . $image_new_name)) {
                $image_url = '/uploads/' . $image_new_name;
            } else {
                $errorMessage = "Error uploading image.";
            }
        }
    } else {
        $image_url = $image;
    }

    if (empty($errorMessage)) {
        $id_villa = $mysqli->real_escape_string($id_villa);
        $image_url = $mysqli->real_escape_string($image_url);

        $sql = "INSERT INTO gallery (id_villa, image) VALUES ('$id_villa', '$image_url')";
        if ($mysqli->query($sql)) {
            $successMessage = "Gallery data added successfully.";
        } else {
            $errorMessage = "Error adding record: " . $mysqli->error;
        }
    }
}
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['edit'])) {
    $id = $_POST['id'];
    $id_villa = $_POST['id_villa'];
    $image = isset($_POST['image']) ? $_POST['image'] : '';
    if (isset($_FILES['image_file']) && $_FILES['image_file']['error'] == 0) {
        $image_file = $_FILES['image_file'];
        $image_name = basename($image_file['name']);
        $image_tmp_name = $image_file['tmp_name'];
        $image_size = $image_file['size'];
        $image_extension = pathinfo($image_name, PATHINFO_EXTENSION);
        $allowed_extensions = ['jpg', 'jpeg', 'png', 'gif'];
        $max_size = 5 * 1024 * 1024;

        if (!in_array(strtolower($image_extension), $allowed_extensions)) {
            $errorMessage = "Invalid file type. Only JPG, JPEG, PNG, and GIF files are allowed.";
        } elseif ($image_size > $max_size) {
            $errorMessage = "File size exceeds the maximum limit of 5MB.";
        } else {
            $image_new_name = uniqid('img_', true) . '.' . $image_extension;
            $upload_dir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
            if (move_uploaded_file($image_tmp_name, $upload_dir . $image_new_name)) {
                $image_url = '/uploads/' . $image_new_name;
            } else {
                $errorMessage = "Error uploading image.";
            }
        }
    } else {
        $image_url = $image;
    }
    if (empty($errorMessage)) {
        $id = (int) $id;
        $id_villa = $mysqli->real_escape_string($id_villa);
        $image_url = $mysqli->real_escape_string($image_url);

        $sql = "UPDATE gallery SET id_villa = '$id_villa', image = '$image_url' WHERE id = $id";
        if ($mysqli->query($sql)) {
            $successMessage = "Gallery data updated successfully.";
        } else {
            $errorMessage = "Error updating record: " . $mysqli->error;
        }
    }
}

if (isset($_GET['delete_id'])) {
    $delete_id = (int) $_GET['delete_id'];
    $sql = "DELETE FROM gallery WHERE id = $delete_id";
    if ($mysqli->query($sql)) {
        $successMessage = "Gallery data deleted successfully.";
    } else {
        $errorMessage = "Error deleting record: " . $mysqli->error;
    }
}

$sql = "SELECT * FROM gallery";
$result = $mysqli->query($sql);



?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>Gallery Management</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <h1 class="h3 mb-4 text-gray-800">Gallery Management</h1>
                    <form action="gallery" method="POST" enctype="multipart/form-data">
                        <h4>Add New Gallery</h4>
                        <div class="form-group">
                            <label for="id_villa">ID Villa</label>
                            <select class="form-control" id="id_villa" name="id_villa" required>
                                <option value="">Select Villa</option>
                                <?php while ($villa_row = $result_villa->fetch_assoc()) { ?>
                                    <option value="<?php echo htmlspecialchars($villa_row['id']); ?>">
                                        <?php echo htmlspecialchars($villa_row['name']); ?>
                                    </option>
                                <?php } ?>
                            </select>
                        </div>

                        <div class="form-group">
                            <label for="image">Image</label>
                            <input type="file" class="form-control" id="image_file" name="image_file" accept="image/*"
                                required>
                        </div>
                        <button type="submit" name="add" class="btn btn-primary">Add Gallery</button>
                    </form>
                    <table class="table table-bordered mt-5">
                        <thead>
                            <tr>
                                <th>Villa</th>
                                <th>Image</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php while ($row = $result->fetch_assoc()) { ?>
                                <tr>
                                    <?php
                                    $id_villa = $row['id_villa'];
                                    $sql_name = "SELECT name FROM properties WHERE id = $id_villa";
                                    $result_name = $mysqli->query($sql_name);
                                    if ($result_name && $result_name->num_rows > 0) {
                                        $villa = $result_name->fetch_assoc();
                                        $villa_name = $villa['name'];
                                    } else {
                                        
                                        $villa_name = "Unknown Villa";
                                    }
                                    ?>
                                    <td><?php echo htmlspecialchars($villa_name); ?></td>
                                    <td><img src="<?php echo htmlspecialchars($row['image']); ?>" width="100" alt="Image">
                                    </td>
                                    <td>
                                        <a href="gallery?id=<?php echo $row['id']; ?>" class="btn btn-info">Edit</a>
                                        <a href="gallery?delete_id=<?php echo $row['id']; ?>" class="btn btn-danger"
                                            onclick="return confirm('Are you sure you want to delete this gallery?');">Delete</a>
                                    </td>
                                </tr>
                            <?php } ?>
                        </tbody>
                    </table>


                </div>
            </div>
        </div>
    </div>

    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>
</body>

</html>