<?php
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $id = $_POST['id'];
    $logo_alt = $_POST['logo_alt'];
    
    if (isset($_FILES['logo_url']) && $_FILES['logo_url']['error'] == 0) {
        $logo_file = $_FILES['logo_url'];
        $logo_name = $logo_file['name'];
        $logo_tmp_name = $logo_file['tmp_name'];
        $logo_size = $logo_file['size'];
        $logo_extension = pathinfo($logo_name, PATHINFO_EXTENSION);
        $allowed_extensions = ['jpg', 'jpeg', 'png', 'gif'];
        $max_size = 5 * 1024 * 1024; // 5MB max
        if (!in_array(strtolower($logo_extension), $allowed_extensions)) {
            $errorMessage = "Invalid file type. Only JPG, JPEG, PNG, and GIF files are allowed.";
        }
        elseif ($logo_size > $max_size) {
            $errorMessage = "File size exceeds the maximum limit of 5MB.";
        } else {
            $logo_new_name = uniqid('logo_', true) . '.' . $logo_extension;
            $upload_dir = $_SERVER['DOCUMENT_ROOT'] . '/uploads/';
            if (move_uploaded_file($logo_tmp_name, $upload_dir . $logo_new_name)) {
                $logo_url = '/uploads/' . $logo_new_name;
            } else {
                $errorMessage = "Error uploading logo image.";
            }
        }
    } else {
        $logo_url = $_POST['logo_url'];
    }
    $logo_url = $mysqli->real_escape_string($logo_url);
    $logo_alt = $mysqli->real_escape_string($logo_alt);
    $id = (int) $id;
    if (!empty($id)) {
        $sql = "UPDATE logo SET 
            logo_url = '$logo_url',
            logo_alt = '$logo_alt'
            WHERE id = $id";
        if ($mysqli->query($sql)) {
            $successMessage = "Logo data updated successfully.";
        } else {
            $errorMessage = "Error updating record: " . $mysqli->error;
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Logo Management</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link
        href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
        rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">
</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <h1 class="h3 mb-4 text-gray-800">Logo Management Form</h1>
                    <form action="logo" method="POST" enctype="multipart/form-data">
                        <div class="form-group">
                            <label for="id">ID</label>
                            <input type="number" class="form-control" id="id" name="id"
                                value="<?= htmlspecialchars($logo['id']) ?>" readonly>
                        </div>

                        <div class="form-group">
                            <label for="logo_url">Logo URL</label>
                            <input type="text" class="form-control" id="logo_url" name="logo_url"
                                value="<?= htmlspecialchars($logo['logo_url']) ?>" readonly>
                        </div>

                        <div class="form-group">
                            <label for="logo_url">Upload New Logo</label>
                            <input type="file" class="form-control" id="logo_url" name="logo_url" accept="image/*">
                        </div>

                        <div class="form-group">
                            <label for="logo_alt">Logo Alt Text</label>
                            <input type="text" class="form-control" id="logo_alt" name="logo_alt"
                                value="<?= htmlspecialchars($logo['logo_alt']) ?>" required>
                        </div>

                        <button type="submit" class="btn btn-primary">Save Logo Data</button>
                    </form>
                    <?php if (isset($logo['logo_url']) && !empty($logo['logo_url'])) : ?>
                        <div class="mt-4">
                            <img src="<?= htmlspecialchars($logo['logo_url']) ?>" alt="<?= htmlspecialchars($logo['logo_alt']) ?>" class="img-fluid w-25" />

                        </div>
                    <?php endif; ?>
                </div>
            </div>

            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Copyright &copy; Your Website 2021</span>
                    </div>
                </div>
            </footer>
        </div>
    </div>

    <div class="modal fade" id="statusModal" tabindex="-1" role="dialog" aria-labelledby="statusModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="statusModalLabel">Status</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <?php if (!empty($successMessage)) : ?>
                        <div class="alert alert-success">
                            <?php echo $successMessage; ?>
                        </div>
                    <?php elseif (!empty($errorMessage)) : ?>
                        <div class="alert alert-danger">
                            <?php echo $errorMessage; ?>
                        </div>
                    <?php endif; ?>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>

    <script>
        $(document).ready(function() {
            <?php if (!empty($successMessage) || !empty($errorMessage)) : ?>
                $('#statusModal').modal('show');
            <?php endif; ?>
        });
    </script>
</body>

</html>
