<?php 
include $_SERVER['DOCUMENT_ROOT'] . '/config/conn.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    // Get POST data
    $id = $_POST['id'];
    $page_url = $_POST['page_url'];
    $title = $_POST['title'];
    $meta_description = $_POST['meta_description'];
    $meta_keywords = $_POST['meta_keywords'];
    $robots_meta_tag = $_POST['robots_meta_tag'];
    $canonical_url = $_POST['canonical_url'];
    $og_url = $_POST['og_url'];
    $og_site_name = $_POST['og_site_name'];
    $og_locale = $_POST['og_locale'];
    $og_type = $_POST['og_type'];
    $og_title = $_POST['og_title'];
    $og_description = $_POST['og_description'];
    $og_image = $_POST['og_image'];
    $twitter_card = $_POST['twitter_card'];
    $twitter_title = $_POST['twitter_title'];
    $twitter_description = $_POST['twitter_description'];
    $twitter_image = $_POST['twitter_image'];
    $rss_feed_url = $_POST['rss_feed_url'];
    $created_at = $_POST['created_at'];
    $updated_at = $_POST['updated_at'];

    // Handle file uploads
    $icon_small = "";
    $icon_big = "";

    if (isset($_FILES['icon_small']) && $_FILES['icon_small']['error'] == 0) {
        // Upload small icon
        $icon_small = 'uploads/' . basename($_FILES['icon_small']['name']);
        move_uploaded_file($_FILES['icon_small']['tmp_name'], $_SERVER['DOCUMENT_ROOT'] . '/' . $icon_small);
    }

    if (isset($_FILES['icon_big']) && $_FILES['icon_big']['error'] == 0) {
        // Upload big icon
        $icon_big = 'uploads/' . basename($_FILES['icon_big']['name']);
        move_uploaded_file($_FILES['icon_big']['tmp_name'], $_SERVER['DOCUMENT_ROOT'] . '/' . $icon_big);
    }

    // Escape the input to prevent SQL injection
    $page_url = $mysqli->real_escape_string($page_url);
    $title = $mysqli->real_escape_string($title);
    $meta_description = $mysqli->real_escape_string($meta_description);
    $meta_keywords = $mysqli->real_escape_string($meta_keywords);
    $robots_meta_tag = $mysqli->real_escape_string($robots_meta_tag);
    $canonical_url = $mysqli->real_escape_string($canonical_url);
    $og_url = $mysqli->real_escape_string($og_url);
    $og_site_name = $mysqli->real_escape_string($og_site_name);
    $og_locale = $mysqli->real_escape_string($og_locale);
    $og_type = $mysqli->real_escape_string($og_type);
    $og_title = $mysqli->real_escape_string($og_title);
    $og_description = $mysqli->real_escape_string($og_description);
    $og_image = $mysqli->real_escape_string($og_image);
    $twitter_card = $mysqli->real_escape_string($twitter_card);
    $twitter_title = $mysqli->real_escape_string($twitter_title);
    $twitter_description = $mysqli->real_escape_string($twitter_description);
    $twitter_image = $mysqli->real_escape_string($twitter_image);
    $rss_feed_url = $mysqli->real_escape_string($rss_feed_url);
    $created_at = $mysqli->real_escape_string($created_at);
    $updated_at = $mysqli->real_escape_string($updated_at);
    $id = (int) $id; // id is an integer

    // Check if we're updating an existing record
    if (!empty($id)) {
        // Create the SQL query with the escaped values
        $sql = "UPDATE seo_meta_data SET 
            page_url = '$page_url',
            title = '$title',
            meta_description = '$meta_description',
            meta_keywords = '$meta_keywords',
            robots_meta_tag = '$robots_meta_tag',
            canonical_url = '$canonical_url',
            og_url = '$og_url',
            og_site_name = '$og_site_name',
            og_locale = '$og_locale',
            og_type = '$og_type',
            og_title = '$og_title',
            og_description = '$og_description',
            og_image = '$og_image',
            twitter_card = '$twitter_card',
            twitter_title = '$twitter_title',
            twitter_description = '$twitter_description',
            twitter_image = '$twitter_image',
            rss_feed_url = '$rss_feed_url',
            icon_small = '$icon_small',
            icon_big = '$icon_big',
            created_at = '$created_at',
            updated_at = '$updated_at'
            WHERE id = $id";

        // Execute the query
        if ($mysqli->query($sql)) {
            $successMessage = "SEO metadata updated successfully.";
        } else {
            $errorMessage = "Error updating record: " . $mysqli->error;
        }
    }
}
?>



<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>SEO Metadata Management</title>
    <link href="vendor/fontawesome-free/css/all.min.css" rel="stylesheet" type="text/css">
    <link
        href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
        rel="stylesheet">
    <link href="css/sb-admin-2.min.css" rel="stylesheet">

</head>

<body id="page-top">
    <div id="wrapper">
        <?php include $_SERVER['DOCUMENT_ROOT'] . '/admin/include/navbar.php'; ?>

        <div id="content-wrapper" class="d-flex flex-column">
            <div id="content">
                <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">
                    <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                        <i class="fa fa-bars"></i>
                    </button>
                </nav>

                <div class="container-fluid">
                    <!-- Page Heading -->
                    <h1 class="h3 mb-4 text-gray-800">SEO Metadata Form</h1>

                    <!-- SEO Form -->
                    <form action="meta" method="POST" enctype="multipart/form-data">
                        <div class="form-group">
                            <label for="id">ID</label>
                            <input type="number" class="form-control" id="id" name="id"
                                value="<?= htmlspecialchars($seo['id']) ?>" readonly>
                        </div>

                        <div class="form-group">
                            <label for="page_url">Page URL</label>
                            <input type="text" class="form-control" id="page_url" name="page_url"
                                value="<?= htmlspecialchars($seo['page_url']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" class="form-control" id="title" name="title"
                                value="<?= htmlspecialchars($seo['title']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="meta_description">Meta Description</label>
                            <textarea class="form-control" id="meta_description" name="meta_description" rows="3"
                                required><?= htmlspecialchars($seo['meta_description']) ?></textarea>
                        </div>

                        <div class="form-group">
                            <label for="meta_keywords">Meta Keywords</label>
                            <input type="text" class="form-control" id="meta_keywords" name="meta_keywords"
                                value="<?= htmlspecialchars($seo['meta_keywords']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="robots_meta_tag">Robots Meta Tag</label>
                            <input type="text" class="form-control" id="robots_meta_tag" name="robots_meta_tag"
                                value="<?= htmlspecialchars($seo['robots_meta_tag']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="canonical_url">Canonical URL</label>
                            <input type="text" class="form-control" id="canonical_url" name="canonical_url"
                                value="<?= htmlspecialchars($seo['canonical_url']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_url">OG URL</label>
                            <input type="text" class="form-control" id="og_url" name="og_url"
                                value="<?= htmlspecialchars($seo['og_url']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_site_name">OG Site Name</label>
                            <input type="text" class="form-control" id="og_site_name" name="og_site_name"
                                value="<?= htmlspecialchars($seo['og_site_name']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_locale">OG Locale</label>
                            <input type="text" class="form-control" id="og_locale" name="og_locale"
                                value="<?= htmlspecialchars($seo['og_locale']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_type">OG Type</label>
                            <input type="text" class="form-control" id="og_type" name="og_type"
                                value="<?= htmlspecialchars($seo['og_type']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_title">OG Title</label>
                            <input type="text" class="form-control" id="og_title" name="og_title"
                                value="<?= htmlspecialchars($seo['og_title']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="og_description">OG Description</label>
                            <textarea class="form-control" id="og_description" name="og_description" rows="3"
                                required><?= htmlspecialchars($seo['og_description']) ?></textarea>
                        </div>

                        <div class="form-group">
                            <label for="og_image">OG Image URL</label>
                            <input type="text" class="form-control" id="og_image" name="og_image"
                                value="<?= htmlspecialchars($seo['og_image']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="twitter_card">Twitter Card</label>
                            <input type="text" class="form-control" id="twitter_card" name="twitter_card"
                                value="<?= htmlspecialchars($seo['twitter_card']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="twitter_title">Twitter Title</label>
                            <input type="text" class="form-control" id="twitter_title" name="twitter_title"
                                value="<?= htmlspecialchars($seo['twitter_title']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="twitter_description">Twitter Description</label>
                            <textarea class="form-control" id="twitter_description" name="twitter_description" rows="3"
                                required><?= htmlspecialchars($seo['twitter_description']) ?></textarea>
                        </div>

                        <div class="form-group">
                            <label for="twitter_image">Twitter Image URL</label>
                            <input type="text" class="form-control" id="twitter_image" name="twitter_image"
                                value="<?= htmlspecialchars($seo['twitter_image']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="rss_feed_url">RSS Feed URL</label>
                            <input type="text" class="form-control" id="rss_feed_url" name="rss_feed_url"
                                value="<?= htmlspecialchars($seo['rss_feed_url']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="created_at">Created At</label>
                            <input type="datetime-local" class="form-control" id="created_at" name="created_at"
                                value="<?= htmlspecialchars($seo['created_at']) ?>" required>
                        </div>

                        <div class="form-group">
                            <label for="updated_at">Updated At</label>
                            <input type="datetime-local" class="form-control" id="updated_at" name="updated_at"
                                value="<?= htmlspecialchars($seo['updated_at']) ?>" required>
                        </div>

                        <!-- New fields for small and big icons -->
                        <div class="form-group">
                            <label for="icon_small">Small Icon (Upload)</label>
                            <input type="file" class="form-control-file" id="icon_small" name="icon_small">
                            <small class="form-text text-muted">Upload a small icon image (e.g., 16x16 px).</small>
                        </div>

                        <div class="form-group">
                            <label for="icon_big">Big Icon (Upload)</label>
                            <input type="file" class="form-control-file" id="icon_big" name="icon_big">
                            <small class="form-text text-muted">Upload a big icon image (e.g., 32x32 px).</small>
                        </div>

                        <button type="submit" class="btn btn-primary">Save SEO Metadata</button>
                    </form>

                </div>
            </div>


            <footer class="sticky-footer bg-white">
                <div class="container my-auto">
                    <div class="copyright text-center my-auto">
                        <span>Copyright &copy; Your Website 2021</span>
                    </div>
                </div>
            </footer>
        </div>
    </div>
    <div class="modal fade" id="statusModal" tabindex="-1" role="dialog" aria-labelledby="statusModalLabel"
        aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="statusModalLabel">Status</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <?php if (!empty($successMessage)): ?>
                        <div class="alert alert-success">
                            <?php echo $successMessage; ?>
                        </div>
                    <?php elseif (!empty($errorMessage)): ?>
                        <div class="alert alert-danger">
                            <?php echo $errorMessage; ?>
                        </div>
                    <?php endif; ?>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <!-- JS Files -->
    <script src="vendor/jquery/jquery.min.js"></script>
    <script src="vendor/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="vendor/jquery-easing/jquery.easing.min.js"></script>
    <script src="js/sb-admin-2.min.js"></script>

    <script>
        // Show the modal after the page loads if there is a success or error message
        $(document).ready(function () {
            <?php if (!empty($successMessage) || !empty($errorMessage)): ?>
                $('#statusModal').modal('show');
            <?php endif; ?>
        });
    </script>
</body>

</html>