<?php
include $_SERVER['DOCUMENT_ROOT'] . '/include/header.php';
include $_SERVER['DOCUMENT_ROOT'] . '/style/index.php';

$limit = 6;
$page = isset($_GET['page']) ? (int) $_GET['page'] : 1;
$offset = ($page - 1) * $limit;
$search = isset($_GET['q']) ? $_GET['q'] : '';
$location = isset($_GET['rtcl_location']) ? $_GET['rtcl_location'] : '';
$bedrooms = isset($_GET['bedrooms']) ? (int) $_GET['bedrooms'] : 0;
$property_type = isset($_GET['property_type']) ? $_GET['property_type'] : '';
$query_promo = "SELECT * FROM properties WHERE 1";
$guests = isset($_GET['guests']) ? (int) $_GET['guests'] : 1;
$nights = isset($_GET['nights']) ? (int) $_GET['nights'] : 1;
if ($search != '') {
  $query_promo .= " AND (name LIKE '%$search%' OR location LIKE '%$search%')";
}
if ($location != '') {
  $query_promo .= " AND location LIKE '%$location%'";
}
$query_promo .= " LIMIT $limit OFFSET $offset";

$result_properties_promo = $mysqli->query($query_promo);
if (!$result_properties_promo) {
  die("Query gagal: " . $mysqli->error);
}

$query_latest = "SELECT * FROM properties WHERE 1";
if ($search != '') {
  $query_latest .= " AND (name LIKE '%$search%' OR location LIKE '%$search%')";
}
if ($location != '') {
  $query_latest .= " AND location LIKE '%$location%'";
}
$query_latest .= " LIMIT $limit OFFSET $offset";

$result_properties_latest = $mysqli->query($query_latest);
if (!$result_properties_latest) {
  die("Query gagal: " . $mysqli->error);
}

$total_query = "SELECT COUNT(*) AS total FROM properties WHERE 1";
if ($search != '') {
  $total_query .= " AND (name LIKE '%$search%' OR location LIKE '%$search%')";
}
if ($location != '') {
  $total_query .= " AND location LIKE '%$location%'";
}
$total_result = $mysqli->query($total_query);
if (!$total_result) {
  die("Query total gagal: " . $mysqli->error);
}
$total_row = $total_result->fetch_assoc();
$total_properties = $total_row['total'];
$total_pages = ceil($total_properties / $limit);

$location_query = "SELECT location FROM properties WHERE location != ''";
$result_locations = $mysqli->query($location_query);
if (!$result_locations) {
  die("Query lokasi gagal: " . $mysqli->error);
}
$locations_array = [];

while ($location_row = $result_locations->fetch_assoc()) {
  $locations = explode(',', $location_row['location']);
  foreach ($locations as $loc) {
    $loc = trim($loc);
    if (!in_array($loc, $locations_array)) {
      $locations_array[] = $loc;
    }
  }
}
sort($locations_array);
?>
</head>

<body>
  <a href="https://wa.me/<?php echo htmlspecialchars($footer['wa']); ?>" class="whatsapp-button" target="_blank">
    <i class="fab fa-whatsapp"></i>
  </a>
  <?php include $_SERVER['DOCUMENT_ROOT'] . '/include/navbar.php'; ?>

  <div class="hero-section">
    <img alt="Hero Image" src="<?php echo $slider['bg']; ?>" style=" width: 100%; height: 600px;" />
    <div class="hero-text">
      <h1><?php echo $slider['one']; ?></h1>
      <p><?php echo $slider['two']; ?></p>
    </div>
  </div>

  <div class="search-section">

    <form method="GET" action="">
      <div class="form-group">
        <label for="search">Search</label>
        <input type="text" id="search" name="q" placeholder="Search..."
          value="<?php echo htmlspecialchars($search); ?>">
      </div>
      <div class="form-group">
        <label for="rtcl_location">Location</label>
        <select id="rtcl_location" name="rtcl_location">
          <option value="" disabled selected>Select Location</option>
          <?php foreach ($locations_array as $loc) { ?>
            <option value="<?php echo htmlspecialchars($loc); ?>" <?php echo $loc === $location ? 'selected' : ''; ?>>
              <?php echo htmlspecialchars($loc); ?>
            </option>
          <?php } ?>
        </select>
      </div>

      <div class="form-group">
        <label for="guests">Jumlah Tamu</label>
        <input type="number" id="guests" name="guests" placeholder="Jumlah Tamu"
          value="<?php echo htmlspecialchars($guests); ?>" min="1">
      </div>

      <div class="form-group">
        <label for="nights">Hari</label>
        <input type="number" id="nights" name="nights" placeholder="Jumlah Malam"
          value="<?php echo htmlspecialchars($nights); ?>" min="1">
      </div>

      <div class="form-group">
        <button type="submit">Search</button>
      </div>
    </form>
  </div>


  <div class="container latest-villa-section">
    <div class="row">
      <?php while ($property = $result_properties_latest->fetch_assoc()) { ?>
        <div class="col-md-3">
          <div class="card">
            <img class="card-img-top" height="200" src="<?php echo $property['image']; ?>" width="350" />
            <div class="card-body">
              <h5 class="card-title">
                <?php echo $property['name']; ?>
              </h5>
              <div class="icon-text">
                <p>
                  <i class="fas fa-user-friends"></i> <?php echo $property['capacity']; ?> Kapasitas
                </p>
              </div>
              <p class="card-text">
                <?php
                $facilities = $property['facilities'];
                $maxLength = 100;
                if (strlen($facilities) > $maxLength) {
                  $facilities = substr($facilities, 0, $maxLength) . '... lihat';
                }
                ?>
                <?php echo $facilities; ?>
              </p>


              <?php
              $propertyName = urlencode($property['name']);
              $capacity = $property['capacity'];
              $facilities = urlencode($property['facilities']);
              $whatsappMessage = "Halo, saya tertarik dengan villa " . $property['name'] . ". Kapasitas: " . $capacity . ". Fasilitas: " . $property['facilities'] . ". Apakah villa ini masih tersedia?";
              $whatsappLink = "https://wa.me/" . urlencode($footer['wa']) . "?text=" . urlencode($whatsappMessage);
              ?>
              <a class="btn btn-primary" href="<?php echo $whatsappLink; ?>" target="_blank">
                Booking Villa
              </a>

              <div class="facilities text-center mt-3">
                <i class="fas fa-utensils"></i>
                <i class="fas fa-swimmer"></i>
                <i class="fas fa-wifi"></i>
                <i class="fas fa-concierge-bell"></i>
                <a class="text-dark text-decoration-none" href="villa">
                  Lihat Selengkapnya
                  <i class="fas fa-chevron-right"></i>
                </a>
              </div>
            </div>
          </div>
        </div>
      <?php } ?>

    </div>
    <div class="pagination-wrapper">
      <ul class="pagination justify-content-center">
        <?php if ($page > 1) { ?>
          <li class="page-item">
            <a class="page-link"
              href="?page=<?php echo $page - 1; ?>&q=<?php echo urlencode($search); ?>&rtcl_location=<?php echo urlencode($location); ?>&min_price=<?php echo urlencode($min_price); ?>&max_price=<?php echo urlencode($max_price); ?>&bedrooms=<?php echo urlencode($bedrooms); ?>&property_type=<?php echo urlencode($property_type); ?>">Previous</a>
          </li>
        <?php } ?>

        <?php for ($i = 1; $i <= $total_pages; $i++) { ?>
          <li class="page-item <?php echo $i == $page ? 'active' : ''; ?>">
            <a class="page-link"
              href="?page=<?php echo $i; ?>&q=<?php echo urlencode($search); ?>&rtcl_location=<?php echo urlencode($location); ?>&min_price=<?php echo urlencode($min_price); ?>&max_price=<?php echo urlencode($max_price); ?>&bedrooms=<?php echo urlencode($bedrooms); ?>&property_type=<?php echo urlencode($property_type); ?>">
              <?php echo $i; ?>
            </a>
          </li>
        <?php } ?>

        <?php if ($page < $total_pages) { ?>
          <li class="page-item">
            <a class="page-link"
              href="?page=<?php echo $page + 1; ?>&q=<?php echo urlencode($search); ?>&rtcl_location=<?php echo urlencode($location); ?>&min_price=<?php echo urlencode($min_price); ?>&max_price=<?php echo urlencode($max_price); ?>&bedrooms=<?php echo urlencode($bedrooms); ?>&property_type=<?php echo urlencode($property_type); ?>">Next</a>
          </li>
        <?php } ?>
      </ul>
    </div>
  </div>

  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js"></script>
</body>
<?php
include $_SERVER['DOCUMENT_ROOT'] . '/include/footer.php';
?>

</html>