<?php
include $_SERVER['DOCUMENT_ROOT'] . '/include/header.php';
include $_SERVER['DOCUMENT_ROOT'] . '/style/kontak.php';

$limit = 9;
$page = isset($_GET['page']) ? (int) $_GET['page'] : 1;
$offset = ($page - 1) * $limit;
$search = isset($_GET['q']) ? $_GET['q'] : '';
$location = isset($_GET['rtcl_location']) ? $_GET['rtcl_location'] : '';
$min_price = isset($_GET['min_price']) ? (float) $_GET['min_price'] : 0;
$max_price = isset($_GET['max_price']) ? (float) $_GET['max_price'] : PHP_INT_MAX;
$guests = isset($_GET['guests']) ? (int) $_GET['guests'] : 1;
$nights = isset($_GET['nights']) ? (int) $_GET['nights'] : 1;

$query = "SELECT * FROM properties WHERE 1";
if ($search != '') {
    $query .= " AND (name LIKE '%$search%' OR location LIKE '%$search%')";
}
if ($location != '') {
    $query .= " AND location LIKE '%$location%'";
}
if ($min_price > 0) {
    $query .= " AND price >= $min_price";
}
if ($max_price < PHP_INT_MAX) {
    $query .= " AND price <= $max_price";
}
$query .= " LIMIT $limit OFFSET $offset";

$result_properties = $mysqli->query($query);
if (!$result_properties) {
    die("Query failed: " . $mysqli->error);
}

$total_query = "SELECT COUNT(*) AS total FROM properties WHERE 1";
if ($search != '') {
    $total_query .= " AND (name LIKE '%$search%' OR location LIKE '%$search%')";
}
if ($location != '') {
    $total_query .= " AND location LIKE '%$location%'";
}
$total_result = $mysqli->query($total_query);
if (!$total_result) {
    die("Query total failed: " . $mysqli->error);
}
$total_row = $total_result->fetch_assoc();
$total_properties = $total_row['total'];
$total_pages = ceil($total_properties / $limit);

$location_query = "SELECT location FROM properties WHERE location != ''";
$result_locations = $mysqli->query($location_query);
if (!$result_locations) {
    die("Query for locations failed: " . $mysqli->error);
}

$locations_array = [];
while ($location_row = $result_locations->fetch_assoc()) {
    $locations = explode(',', $location_row['location']);
    foreach ($locations as $loc) {
        $loc = trim($loc);
        if (!in_array($loc, $locations_array)) {
            $locations_array[] = $loc;
        }
    }
}
sort($locations_array);
?>
<link rel="stylesheet" href="https://unpkg.com/swiper/swiper-bundle.min.css">
<style>
    .swiper-container {
        width: 100%;
        height: 200px;
        overflow: hidden;
    }

    .swiper-slide {
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .swiper-slide img {
        width: 100%;
        height: 100%;
        object-fit: cover;
    }
</style>

</head>

<body>
    <a href="https://wa.me/<?php echo htmlspecialchars($footer['wa']); ?>" class="whatsapp-button" target="_blank">
        <i class="fab fa-whatsapp"></i>
    </a>
    <?php include $_SERVER['DOCUMENT_ROOT'] . '/include/navbar.php'; ?>

    <div class="container mt-4">
        <div class="row">
            <div class="col-md-3">
                <div class="search-section">
                    <form method="GET">
                        <div class="mb-3">
                            <label class="form-label" for="checkin">Check-in</label>
                            <input class="form-control" id="checkin" type="date" name="checkin" />
                        </div>
                        <div class="mb-3">
                            <label class="form-label" for="checkout">Check-out</label>
                            <input class="form-control" id="checkout" type="date" name="checkout" />
                        </div>
                        <div class="mb-3">
                            <label class="form-label" for="nights">Malam</label>
                            <input class="form-control" id="nights" type="number" name="nights"
                                value="<?php echo $nights; ?>" />
                        </div>
                        <div class="mb-3">
                            <label class="form-label" for="location">Lokasi</label>
                            <select class="form-select" id="location" name="rtcl_location">
                                <option value="">Pilih...</option>
                                <?php foreach ($locations_array as $loc) { ?>
                                    <option value="<?php echo htmlspecialchars($loc); ?>" <?php echo ($location == $loc) ? 'selected' : ''; ?>>
                                        <?php echo htmlspecialchars($loc); ?>
                                    </option>
                                <?php } ?>
                            </select>
                        </div>
                        <button type="submit" class="btn btn-primary">Search</button>
                    </form>
                </div>
            </div>

            <div class="col-md-9">
                <div class="row">
                    <?php while ($property = $result_properties->fetch_assoc()) { ?>
                        <div class="col-md-4">
                            <div class="card villa-card">
                                <img class="card-img-top" height="200" src="<?php echo $property['image']; ?>"
                                    width="350" />
                                <div class="card-body">
                                    <h5 class="card-title"><?php echo $property['name']; ?></h5>
                                    <p class="card-text">
                                        <i class="fas fa-users"></i><?php echo $property['capacity']; ?> Kapasitas
                                    </p>
                                    <p class="card-text">
                                        <?php
                                        $facilities = $property['facilities'];
                                        $maxLength = 100;
                                        if (strlen($facilities) > $maxLength) {
                                            $facilities = substr($facilities, 0, $maxLength) . '... lihat';
                                        }
                                        echo $facilities;
                                        ?>
                                    </p>
                                </div>

                                <div class="facilities text-center mt-3">
                                    <i class="fas fa-utensils"></i>
                                    <i class="fas fa-swimmer"></i>
                                    <i class="fas fa-wifi"></i>
                                    <i class="fas fa-concierge-bell"></i>
                                    <a class="text-dark text-decoration-none" href="#" data-bs-toggle="modal"
                                        data-bs-target="#propertyModal<?php echo $property['id']; ?>">
                                        Lihat Selengkapnya
                                        <i class="fas fa-chevron-right"></i>
                                    </a>
                                </div>
                                <div class="card-footer text-center">
                                    <?php
                                    $propertyName = urlencode($property['name']);
                                    $capacity = $property['capacity'];
                                    $facilities = urlencode($property['facilities']);
                                    $whatsappMessage = "Halo, saya tertarik dengan villa " . $property['name'] . ". Kapasitas: " . $capacity . ". Fasilitas: " . $property['facilities'] . ". Apakah villa ini masih tersedia?";
                                    $whatsappLink = "https://wa.me/" . urlencode($footer['wa']) . "?text=" . urlencode($whatsappMessage);
                                    ?>
                                    <a href="<?php echo $whatsappLink; ?>" target="_blank"
                                        class="btn btn-primary">Booking</a>
                                </div>
                            </div>
                        </div>
                        <div class="modal fade" id="propertyModal<?php echo $property['id']; ?>" tabindex="-1"
                            aria-labelledby="propertyModalLabel" aria-hidden="true">
                            <div class="modal-dialog">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="propertyModalLabel"><?php echo $property['name']; ?>
                                        </h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal"
                                            aria-label="Close"></button>
                                    </div>
                                    <div class="modal-body">
                                        <div class="card">
                                            <div class="card-body">
                                                <div class="swiper-container mb-3">
                                                    <div class="swiper-wrapper">
                                                        <?php

                                                        $id_villa = $property['id'];
                                                        $sql_gallery = "SELECT image FROM gallery WHERE id_villa = $id_villa";
                                                        $result_gallery = $mysqli->query($sql_gallery);

                                                        if ($result_gallery && $result_gallery->num_rows > 0) {

                                                            while ($gallery = $result_gallery->fetch_assoc()) {
                                                                echo '<div class="swiper-slide">
                                                <img src="' . htmlspecialchars($gallery['image']) . '" alt="Gallery Image" class="img-fluid">
                                              </div>';
                                                            }
                                                        } else {
                                                            echo '<p>No images available in the gallery.</p>';
                                                        }
                                                        ?>
                                                    </div>

                                                    <div class="swiper-pagination"></div>

                                                </div>


                                                <ul class="nav nav-tabs" id="propertyTabs<?php echo $property['id']; ?>"
                                                    role="tablist">
                                                    <li class="nav-item" role="presentation">
                                                        <a class="nav-link active"
                                                            id="location-tab-<?php echo $property['id']; ?>"
                                                            data-bs-toggle="tab"
                                                            href="#location-<?php echo $property['id']; ?>" role="tab"
                                                            aria-controls="location-<?php echo $property['id']; ?>"
                                                            aria-selected="true">Location</a>
                                                    </li>
                                                    <li class="nav-item" role="presentation">
                                                        <a class="nav-link" id="price-tab-<?php echo $property['id']; ?>"
                                                            data-bs-toggle="tab"
                                                            href="#price-<?php echo $property['id']; ?>" role="tab"
                                                            aria-controls="price-<?php echo $property['id']; ?>"
                                                            aria-selected="false">Price</a>
                                                    </li>
                                                    <li class="nav-item" role="presentation">
                                                        <a class="nav-link" id="details-tab-<?php echo $property['id']; ?>"
                                                            data-bs-toggle="tab"
                                                            href="#details-<?php echo $property['id']; ?>" role="tab"
                                                            aria-controls="details-<?php echo $property['id']; ?>"
                                                            aria-selected="false">Details</a>
                                                    </li>
                                                    <li class="nav-item" role="presentation">
                                                        <a class="nav-link"
                                                            id="facilities-tab-<?php echo $property['id']; ?>"
                                                            data-bs-toggle="tab"
                                                            href="#facilities-<?php echo $property['id']; ?>" role="tab"
                                                            aria-controls="facilities-<?php echo $property['id']; ?>"
                                                            aria-selected="false">Facilities</a>
                                                    </li>
                                                </ul>


                                                <div class="tab-content mt-3"
                                                    id="propertyTabsContent<?php echo $property['id']; ?>">

                                                    <div class="tab-pane fade show active"
                                                        id="location-<?php echo $property['id']; ?>" role="tabpanel"
                                                        aria-labelledby="location-tab-<?php echo $property['id']; ?>">
                                                        <p><strong>Location:</strong> <?php echo $property['location']; ?>
                                                        </p>
                                                    </div>

                                                    <!-- Price Tab -->
                                                    <div class="tab-pane fade" id="price-<?php echo $property['id']; ?>"
                                                        role="tabpanel"
                                                        aria-labelledby="price-tab-<?php echo $property['id']; ?>">
                                                        <p><strong>Price Weekday:</strong>
                                                            <?php echo $property['price_weekday']; ?></p>
                                                        <p><strong>Price Weekend:</strong>
                                                            <?php echo $property['price_weekend']; ?></p>
                                                    </div>

                                                    <!-- Details Tab -->
                                                    <div class="tab-pane fade" id="details-<?php echo $property['id']; ?>"
                                                        role="tabpanel"
                                                        aria-labelledby="details-tab-<?php echo $property['id']; ?>">
                                                        <p><strong>Capacity:</strong> <?php echo $property['capacity']; ?>
                                                        </p>
                                                        <p><strong>Rooms:</strong> <?php echo $property['rooms']; ?></p>
                                                        <p><strong>Beds:</strong> <?php echo $property['beds']; ?></p>
                                                        <p><strong>Bathrooms:</strong> <?php echo $property['bathrooms']; ?>
                                                        </p>
                                                    </div>

                                                    <!-- Facilities Tab -->
                                                    <div class="tab-pane fade"
                                                        id="facilities-<?php echo $property['id']; ?>" role="tabpanel"
                                                        aria-labelledby="facilities-tab-<?php echo $property['id']; ?>">
                                                        <p><strong>Facilities:</strong>
                                                            <?php echo $property['facilities']; ?></p>
                                                    </div>
                                                </div>

                                            </div>
                                        </div>
                                    </div>
                                    <div class="card-footer text-center">
                                        <?php
                                        $propertyName = urlencode($property['name']);
                                        $capacity = $property['capacity'];
                                        $facilities = urlencode($property['facilities']);
                                        $whatsappMessage = "Halo, saya tertarik dengan villa " . $property['name'] . ". Kapasitas: " . $capacity . ". Fasilitas: " . $property['facilities'] . ". Apakah villa ini masih tersedia?";
                                        $whatsappLink = "https://wa.me/" . urlencode($footer['wa']) . "?text=" . urlencode($whatsappMessage);
                                        ?>
                                        <a href="<?php echo $whatsappLink; ?>" target="_blank"
                                            class="btn btn-primary">Booking</a>
                                    </div>
                                </div>
                            </div>
                        </div>


                    <?php } ?>
                </div>
                <br>
                <br>
            </div>
        </div>
    </div>
    <script>
        document.addEventListener('DOMContentLoaded', function () {
            var swiper = new Swiper('.swiper-container', {
                loop: true,
                pagination: {
                    el: '.swiper-pagination',
                    clickable: true,
                },
                navigation: {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev',
                },
                spaceBetween: 10,
                slidesPerView: 1,
                breakpoints: {
                    640: {
                        slidesPerView: 1,
                    },
                    768: {
                        slidesPerView: 2,
                    },
                    1024: {
                        slidesPerView: 3,
                    },
                }
            });
        });


    </script>
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.11.6/dist/umd/popper.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.min.js"></script>
    <!-- Swiper JS -->
    <script src="https://unpkg.com/swiper/swiper-bundle.min.js"></script>

</body>
<?php
include $_SERVER['DOCUMENT_ROOT'] . '/include/footer.php';
?>
</html>